# -*- coding: utf-8 -*-

# Zope
from zope import i18n
from zope.event import notify
from zope.formlib import form
from zope.component import getMultiAdapter
from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile

# Five
from Products.Five.formlib import formbase

# Locals
from events         import TreeUpdateEvent
from widgets        import KeywordsRestrictionWidget
from interfaces     import ICustomizableCloud

# Internationalization
_ = i18n.MessageIDFactory("vaporisation")


class CloudPreferencesForm( formbase.EditForm ):
    """
    This is the edit form of the clouded keywords
    It will handle the simple customizations.
    """
    # This should be handled with a named templated adaptation
    base_template = form.EditForm.template
    template = ViewPageTemplateFile('templates/cloud_preferences.pt')
    
    # Here we trigger the event to recreate the tree
    # if there's any change. Otherwise, we just warn
    # about the uselessness of pressing save if there's
    # no changes :)
    @form.action(_(u"label_save", default=u"Save"),
                 condition=form.haveInputWidgets,
                 name=u'save')
    def handle_save_action(self, action, data):
        if form.applyChanges(self.context, self.form_fields,
                             data, self.adapters):
            notify(TreeUpdateEvent(self.context))
            self.status = _(u"Changes saved and tagcloud updated.")
        else:
            self.status = _(u"No changes.")


    # For the form details
    label       = _(u"Cloud preferences")
    form_name   = _(u"Cloud advanced configuration")
    description = _(u"The fields below allow you to customize your cloud.")

    # About the fields
    form_fields = form.FormFields( ICustomizableCloud )
    form_fields['restrict'].custom_widget = KeywordsRestrictionWidget


