# -*- coding: utf-8 -*-

from zope.app.schema.vocabulary import IVocabularyFactory
from zope.interface.declarations import directlyProvides, implements
from zope.schema.vocabulary import SimpleVocabulary
from Products.CMFCore.utils import getToolByName
from zope.schema.interfaces import ITokenizedTerm, ITitledTokenizedTerm

class KeywordTerm(object):
    """Simple tokenized keyword used by SimpleVocabulary."""
    
    implements(ITokenizedTerm)
    
    def __init__(self, value):
        """Create a term from the single value
        This class overrides the use of SimpleTerm
        which is totally bugged in zope2.9.7
        """
        self.value = value
        self.token = value            
        self.title = value
        directlyProvides(self, ITitledTokenizedTerm)


class KeywordVocabulary(object):
    """Vocabulary factory for keywords of a cloud.
    """
    implements(IVocabularyFactory)

    def __call__(self, context):
        context = getattr(context, 'context', context)
        terms   = [KeywordTerm(k) for k in context.all_keys]
        return SimpleVocabulary(terms)

KeywordVocabularyFactory = KeywordVocabulary()
